const general = require('./generalFunctions');

exports.csvToNestedJson = function (template, csv, debug) {
    //display debug mode message
    if (!!debug == true)
        general.printInfo("DEBUG MDOE ON");

    // get headers
    csvHeaders = format(csv.substring(0, csv.indexOf('\n')));
    csvBody = csv.substring(csv.indexOf('\n') + 1);
    // get rows
    csvRows = getRows(csvBody);
    // fillup the json from the csv

    let json = fetchAll(csvRows, csvHeaders, template);


    return json;
}


String.prototype.replaceAt = function (index, replacement) {
    return this.substr(0, index) + replacement + this.substr(index + replacement.length);
}



const format = function (line) {

    line = (line[line.length - 1] == ',' ? line.slice(0, line.length - 1) : line);
    line = (line[line.length - 1] == '\r' ? line.slice(0, line.length - 1) : line);
    line = (line[line.length - 1] == ',' ? line.slice(0, line.length - 1) : line);

    let replace = false;
    for (let i = 0; i < line.length; i++) {
        if (line[i] == '\"')
            replace = !replace;
        if (replace) {
            if (line[i] == ',')
                line = line.replaceAt(i, '.')
        }
    }

    line = (line[line.length - 1] == '\r' ? line.slice(0, line.length - 1) : line).split(',');
    return line;

}



const getRows = function (csvBody) {
    let lines = csvBody.split('\n');
    let rows = [];
    for (let i = 0; i < lines.length; i++) {
        lines[i] = format(lines[i]);
        rows.push(lines[i]);
    }
    return rows;
}


const fetchAll = function (csvRows, csvHeaders, template) {
    let json = {};
    for (let i = 0; i < csvRows.length; i++) {
        let tempJson = template;
        for (let j = 0; j < csvHeaders.length; j++) {
            tempJson = fetch(csvRows[i][j], csvHeaders[j], tempJson);
        }
        json[csvRows[i][0]] = JSON.parse(JSON.stringify(tempJson));

    }
    return json;
}

const fetch = function (value, path, template) {

    if (value == undefined)
        return template;
    if (path.includes('.')) {
        let current = path.substring(0, path.indexOf('.'));
        let newPath = path.substring(path.indexOf('.') + 1, path.length);
        template[current] = fetch(value, newPath, template[current]);
        return template;
    }
    //TODO:FIXME: fix this stuff
    if (value == 'chips')
        template[path] = {
            "10713129997EGUbJ2": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10713129997EGUbJ2",
                "isPublished": true,
                "isSelected": true,
                "modifierParent": {
                    "id": "10920925318iVlRlE",
                    "isPublished": true,
                    "max": "1",
                    "min": "1`",
                    "nameAr": "نكهة الشيبس",
                    "nameEn": "Chips Flavor",
                    "type": "radio"
                },
                "nameAr": "الأصلي",
                "nameEn": "Original",
                "parentId": "10920925318iVlRlE",
                "price": "0"
            },
            "10920929565mckxSX": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10920929565mckxSX",
                "isPublished": true,
                "isSelected": false,
                "modifierParent": {
                    "id": "10920925318iVlRlE",
                    "isPublished": true,
                    "max": "1",
                    "min": "1",
                    "nameAr": "نكهة الشيبس",
                    "nameEn": "Chips Flavor",
                    "type": "radio"
                },
                "nameAr": "كاتشب",
                "nameEn": "Ketchup",
                "parentId": "10920925318iVlRlE",
                "price": "0"
            },
            "10920929566NUiCOU": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10920929566NUiCOU",
                "isPublished": true,
                "isSelected": false,
                "modifierParent": {
                    "id": "10920925318iVlRlE",
                    "isPublished": true,
                    "max": "1",
                    "min": "1",
                    "nameAr": "نكهة الشيبس",
                    "nameEn": "Chips Flavor",
                    "type": "radio"
                },
                "nameAr": "الشواء",
                "nameEn": "Barbeque",
                "parentId": "10920925318iVlRlE",
                "price": "0"
            },
            "10920929566RTXKUL": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10920929566RTXKUL",
                "isPublished": true,
                "isSelected": false,
                "modifierParent": {
                    "id": "10920925318iVlRlE",
                    "isPublished": true,
                    "max": "1",
                    "min": "1",
                    "nameAr": "نكهة الشيبس",
                    "nameEn": "Chips Flavor",
                    "type": "radio"
                },
                "nameAr": "بابريكا",
                "nameEn": "Paprika",
                "parentId": "10920925318iVlRlE",
                "price": "0"
            }
        };
    if (value == 'juice')
        template[path] = {
            "10920931667GpPRVy": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10920931667GpPRVy",
                "isPublished": true,
                "isSelected": false,
                "modifierParent": {
                    "id": "10713130019iEzQMx",
                    "isPublished": true,
                    "max": "1",
                    "min": "1",
                    "nameAr": "نكهة العصير",
                    "nameEn": "Juice Flavor",
                    "type": "radio"
                },
                "nameAr": "فواكه مشكلة",
                "nameEn": "Mixed Fruite",
                "parentId": "10713130019iEzQMx",
                "price": "0"
            },
            "10920932736weoAFr": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10920932736weoAFr",
                "isPublished": true,
                "isSelected": true,
                "modifierParent": {
                    "id": "10713130019iEzQMx",
                    "isPublished": true,
                    "max": "1",
                    "min": "1",
                    "nameAr": "نكهة العصير",
                    "nameEn": "Juice Flavor",
                    "type": "radio"
                },
                "nameAr": "تفاح",
                "nameEn": "Apple",
                "parentId": "10713130019iEzQMx",
                "price": "0"
            },
            "10920932770LrCRGS": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10920932770LrCRGS",
                "isPublished": true,
                "isSelected": false,
                "modifierParent": {
                    "id": "10713130019iEzQMx",
                    "isPublished": true,
                    "max": "1",
                    "min": "1",
                    "nameAr": "نكهة العصير",
                    "nameEn": "Juice Flavor",
                    "type": "radio"
                },
                "nameAr": "برتقال",
                "nameEn": "Orange",
                "parentId": "10713130019iEzQMx",
                "price": "0"
            },
            "10920933801nuFJYl": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10920933801nuFJYl",
                "isPublished": true,
                "isSelected": false,
                "modifierParent": {
                    "id": "10713130019iEzQMx",
                    "isPublished": true,
                    "max": "1",
                    "min": "1",
                    "nameAr": "نكهة العصير",
                    "nameEn": "Juice Flavor",
                    "type": "radio"
                },
                "nameAr": "منجا",
                "nameEn": "Mango",
                "parentId": "10713130019iEzQMx",
                "price": "0"
            }
        }
    if (value == 'beer')
        template[path] = {
            "10920933824OeCHyT": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10920933824OeCHyT",
                "isPublished": true,
                "isSelected": true,
                "modifierParent": {
                    "id": "10920926362HCyQJp",
                    "isPublished": true,
                    "max": "1",
                    "min": "1",
                    "nameAr": "نكهة البيرة",
                    "nameEn": "Beer Flavor",
                    "type": "radio"
                },
                "nameAr": "شعير",
                "nameEn": "Malt",
                "parentId": "10920926362HCyQJp",
                "price": "0"
            },
            "10920934861hKcEGt": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10920934861hKcEGt",
                "isPublished": true,
                "isSelected": false,
                "modifierParent": {
                    "id": "10920926362HCyQJp",
                    "isPublished": true,
                    "max": "1",
                    "min": "1",
                    "nameAr": "نكهة البيرة",
                    "nameEn": "Beer Flavor",
                    "type": "radio"
                },
                "nameAr": "تفاح",
                "nameEn": "Apple",
                "parentId": "10920926362HCyQJp",
                "price": "0"
            },
            "10920934863pseeAM": {
                "defaultCount": "1",
                "descriptionAr": "",
                "descriptionEn": "",
                "id": "10920934863pseeAM",
                "isPublished": true,
                "isSelected": false,
                "modifierParent": {
                    "id": "10920926362HCyQJp",
                    "isPublished": true,
                    "max": "1",
                    "min": "1",
                    "nameAr": "نكهة البيرة",
                    "nameEn": "Beer Flavor",
                    "type": "radio"
                },
                "nameAr": "ليمون",
                "nameEn": "Lemon",
                "parentId": "10920926362HCyQJp",
                "price": "0"
            }
        }
    if (typeof template[path] != 'string' || typeof template[path] != 'bool' || typeof template[path] != 'int' || typeof template[path] != 'integer' || typeof template[path] != 'boolean');

    else template[path] = value;
    return template;
}